"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DescribeTransitGatewayPolicyTablesCommand = void 0;
const middleware_serde_1 = require("@aws-sdk/middleware-serde");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const models_4_1 = require("../models/models_4");
const Aws_ec2_1 = require("../protocols/Aws_ec2");
class DescribeTransitGatewayPolicyTablesCommand extends smithy_client_1.Command {
    constructor(input) {
        super();
        this.input = input;
    }
    resolveMiddleware(clientStack, configuration, options) {
        this.middlewareStack.use((0, middleware_serde_1.getSerdePlugin)(configuration, this.serialize, this.deserialize));
        const stack = clientStack.concat(this.middlewareStack);
        const { logger } = configuration;
        const clientName = "EC2Client";
        const commandName = "DescribeTransitGatewayPolicyTablesCommand";
        const handlerExecutionContext = {
            logger,
            clientName,
            commandName,
            inputFilterSensitiveLog: models_4_1.DescribeTransitGatewayPolicyTablesRequestFilterSensitiveLog,
            outputFilterSensitiveLog: models_4_1.DescribeTransitGatewayPolicyTablesResultFilterSensitiveLog,
        };
        const { requestHandler } = configuration;
        return stack.resolve((request) => requestHandler.handle(request.request, options || {}), handlerExecutionContext);
    }
    serialize(input, context) {
        return (0, Aws_ec2_1.serializeAws_ec2DescribeTransitGatewayPolicyTablesCommand)(input, context);
    }
    deserialize(output, context) {
        return (0, Aws_ec2_1.deserializeAws_ec2DescribeTransitGatewayPolicyTablesCommand)(output, context);
    }
}
exports.DescribeTransitGatewayPolicyTablesCommand = DescribeTransitGatewayPolicyTablesCommand;
