import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateCoipPoolRequestFilterSensitiveLog, CreateCoipPoolResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_ec2CreateCoipPoolCommand, serializeAws_ec2CreateCoipPoolCommand } from "../protocols/Aws_ec2";
var CreateCoipPoolCommand = (function (_super) {
    __extends(CreateCoipPoolCommand, _super);
    function CreateCoipPoolCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateCoipPoolCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "CreateCoipPoolCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateCoipPoolRequestFilterSensitiveLog,
            outputFilterSensitiveLog: CreateCoipPoolResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateCoipPoolCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2CreateCoipPoolCommand(input, context);
    };
    CreateCoipPoolCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2CreateCoipPoolCommand(output, context);
    };
    return CreateCoipPoolCommand;
}($Command));
export { CreateCoipPoolCommand };
