import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteLocalGatewayRouteTableRequestFilterSensitiveLog, DeleteLocalGatewayRouteTableResultFilterSensitiveLog, } from "../models/models_2";
import { deserializeAws_ec2DeleteLocalGatewayRouteTableCommand, serializeAws_ec2DeleteLocalGatewayRouteTableCommand, } from "../protocols/Aws_ec2";
var DeleteLocalGatewayRouteTableCommand = (function (_super) {
    __extends(DeleteLocalGatewayRouteTableCommand, _super);
    function DeleteLocalGatewayRouteTableCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteLocalGatewayRouteTableCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "DeleteLocalGatewayRouteTableCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteLocalGatewayRouteTableRequestFilterSensitiveLog,
            outputFilterSensitiveLog: DeleteLocalGatewayRouteTableResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteLocalGatewayRouteTableCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2DeleteLocalGatewayRouteTableCommand(input, context);
    };
    DeleteLocalGatewayRouteTableCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2DeleteLocalGatewayRouteTableCommand(output, context);
    };
    return DeleteLocalGatewayRouteTableCommand;
}($Command));
export { DeleteLocalGatewayRouteTableCommand };
