import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteTransitGatewayPolicyTableRequestFilterSensitiveLog, DeleteTransitGatewayPolicyTableResultFilterSensitiveLog, } from "../models/models_2";
import { deserializeAws_ec2DeleteTransitGatewayPolicyTableCommand, serializeAws_ec2DeleteTransitGatewayPolicyTableCommand, } from "../protocols/Aws_ec2";
var DeleteTransitGatewayPolicyTableCommand = (function (_super) {
    __extends(DeleteTransitGatewayPolicyTableCommand, _super);
    function DeleteTransitGatewayPolicyTableCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteTransitGatewayPolicyTableCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "DeleteTransitGatewayPolicyTableCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteTransitGatewayPolicyTableRequestFilterSensitiveLog,
            outputFilterSensitiveLog: DeleteTransitGatewayPolicyTableResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteTransitGatewayPolicyTableCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2DeleteTransitGatewayPolicyTableCommand(input, context);
    };
    DeleteTransitGatewayPolicyTableCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2DeleteTransitGatewayPolicyTableCommand(output, context);
    };
    return DeleteTransitGatewayPolicyTableCommand;
}($Command));
export { DeleteTransitGatewayPolicyTableCommand };
