import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DisassociateTransitGatewayPolicyTableRequestFilterSensitiveLog, DisassociateTransitGatewayPolicyTableResultFilterSensitiveLog, } from "../models/models_4";
import { deserializeAws_ec2DisassociateTransitGatewayPolicyTableCommand, serializeAws_ec2DisassociateTransitGatewayPolicyTableCommand, } from "../protocols/Aws_ec2";
var DisassociateTransitGatewayPolicyTableCommand = (function (_super) {
    __extends(DisassociateTransitGatewayPolicyTableCommand, _super);
    function DisassociateTransitGatewayPolicyTableCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DisassociateTransitGatewayPolicyTableCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "DisassociateTransitGatewayPolicyTableCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DisassociateTransitGatewayPolicyTableRequestFilterSensitiveLog,
            outputFilterSensitiveLog: DisassociateTransitGatewayPolicyTableResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DisassociateTransitGatewayPolicyTableCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2DisassociateTransitGatewayPolicyTableCommand(input, context);
    };
    DisassociateTransitGatewayPolicyTableCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2DisassociateTransitGatewayPolicyTableCommand(output, context);
    };
    return DisassociateTransitGatewayPolicyTableCommand;
}($Command));
export { DisassociateTransitGatewayPolicyTableCommand };
