import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetInstanceUefiDataRequestFilterSensitiveLog, GetInstanceUefiDataResultFilterSensitiveLog, } from "../models/models_5";
import { deserializeAws_ec2GetInstanceUefiDataCommand, serializeAws_ec2GetInstanceUefiDataCommand, } from "../protocols/Aws_ec2";
var GetInstanceUefiDataCommand = (function (_super) {
    __extends(GetInstanceUefiDataCommand, _super);
    function GetInstanceUefiDataCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetInstanceUefiDataCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "GetInstanceUefiDataCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetInstanceUefiDataRequestFilterSensitiveLog,
            outputFilterSensitiveLog: GetInstanceUefiDataResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetInstanceUefiDataCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2GetInstanceUefiDataCommand(input, context);
    };
    GetInstanceUefiDataCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2GetInstanceUefiDataCommand(output, context);
    };
    return GetInstanceUefiDataCommand;
}($Command));
export { GetInstanceUefiDataCommand };
