import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetTransitGatewayPolicyTableEntriesRequestFilterSensitiveLog, GetTransitGatewayPolicyTableEntriesResultFilterSensitiveLog, } from "../models/models_5";
import { deserializeAws_ec2GetTransitGatewayPolicyTableEntriesCommand, serializeAws_ec2GetTransitGatewayPolicyTableEntriesCommand, } from "../protocols/Aws_ec2";
var GetTransitGatewayPolicyTableEntriesCommand = (function (_super) {
    __extends(GetTransitGatewayPolicyTableEntriesCommand, _super);
    function GetTransitGatewayPolicyTableEntriesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetTransitGatewayPolicyTableEntriesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "GetTransitGatewayPolicyTableEntriesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetTransitGatewayPolicyTableEntriesRequestFilterSensitiveLog,
            outputFilterSensitiveLog: GetTransitGatewayPolicyTableEntriesResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetTransitGatewayPolicyTableEntriesCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2GetTransitGatewayPolicyTableEntriesCommand(input, context);
    };
    GetTransitGatewayPolicyTableEntriesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2GetTransitGatewayPolicyTableEntriesCommand(output, context);
    };
    return GetTransitGatewayPolicyTableEntriesCommand;
}($Command));
export { GetTransitGatewayPolicyTableEntriesCommand };
