import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ModifyLocalGatewayRouteRequestFilterSensitiveLog, ModifyLocalGatewayRouteResultFilterSensitiveLog, } from "../models/models_5";
import { deserializeAws_ec2ModifyLocalGatewayRouteCommand, serializeAws_ec2ModifyLocalGatewayRouteCommand, } from "../protocols/Aws_ec2";
var ModifyLocalGatewayRouteCommand = (function (_super) {
    __extends(ModifyLocalGatewayRouteCommand, _super);
    function ModifyLocalGatewayRouteCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ModifyLocalGatewayRouteCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "ModifyLocalGatewayRouteCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ModifyLocalGatewayRouteRequestFilterSensitiveLog,
            outputFilterSensitiveLog: ModifyLocalGatewayRouteResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ModifyLocalGatewayRouteCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2ModifyLocalGatewayRouteCommand(input, context);
    };
    ModifyLocalGatewayRouteCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2ModifyLocalGatewayRouteCommand(output, context);
    };
    return ModifyLocalGatewayRouteCommand;
}($Command));
export { ModifyLocalGatewayRouteCommand };
