import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RestoreImageFromRecycleBinRequestFilterSensitiveLog, RestoreImageFromRecycleBinResultFilterSensitiveLog, } from "../models/models_6";
import { deserializeAws_ec2RestoreImageFromRecycleBinCommand, serializeAws_ec2RestoreImageFromRecycleBinCommand, } from "../protocols/Aws_ec2";
var RestoreImageFromRecycleBinCommand = (function (_super) {
    __extends(RestoreImageFromRecycleBinCommand, _super);
    function RestoreImageFromRecycleBinCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RestoreImageFromRecycleBinCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "RestoreImageFromRecycleBinCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RestoreImageFromRecycleBinRequestFilterSensitiveLog,
            outputFilterSensitiveLog: RestoreImageFromRecycleBinResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RestoreImageFromRecycleBinCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2RestoreImageFromRecycleBinCommand(input, context);
    };
    RestoreImageFromRecycleBinCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2RestoreImageFromRecycleBinCommand(output, context);
    };
    return RestoreImageFromRecycleBinCommand;
}($Command));
export { RestoreImageFromRecycleBinCommand };
